Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0008530opensim[REGION] Specific OpenSim Modulepublic2019-05-21 19:442019-05-22 21:58
ReporterFerd Frederix 
Assigned To 
PrioritynormalSeveritycrashReproducibilityalways
StatusresolvedResolutionopen 
PlatformDreamgrid/OpensimOSWindowsOS Version10
Product Version0.9.0.1 
Target VersionFixed in Version 
Summary0008530: Warp3D kills a region that was working before dev master update
DescriptionAn OAR had been running for long time on a grid (and has 170 downloads) but now it crashes on startup if a map is being made. DreamGrid has been running a 6 month old Opensim. It is now Opensim Dev Master 4/24/2019 #11cad57c9cac5, which now fatal crashes with this one OAR. Out of over 115 OARs, this is the only one to suddenly and fatally crash on startup, and only when a map is being made. Normally I would just call it a "bad oar", but it isn't, and the only difference is a jump in dev master. We have numerous backups of this OAR dating back nearly a year that all how the same bad crash, but only after a update to latest code base.

You can get it here at Outworldz.com, it is "OAR Neverhood oar Avia Bonne.zip", a 1X1 OAR.

https://www.outworldz.com/cgi/sculpt-save.plx?File=/Sculpts/cgi/files/OAR-Neverhood%20oar%20Avia%20Bonne%20.zip [^]

UBODE or Bullet made no difference. Tried it on two different grids. Loading the OAR into a 4X4 makes no difference. It will always crash and cannot be recovered. Deleting map tiles makes no difference. There is no recovery mechanism other than to burn the region to the ground and start over.

The only way I can find to run this region now is to start with maps off, load the oars and never make a map.
Steps To ReproduceStart with blank region set for generating a map with Warp3D. Such as editing the digits in the UUID. It will generate a pimple island map. Now load the oar. It will start right up as maps are not generated on load oar.

Type 'generate map' and the map engine will crash, but the region will remain up. On exit I have seen it complain about the map tile image being locked.

When shutdown you will likely get a yellow warning from the map module:

17:30:55 - [WATCHDOG]: Timeout detected for thread "MapItemRequestThread (Zenith)". ThreadState=Background, WaitSleepJoin. Last tick was 5297ms ago.
17:30:58 - [WATCHDOG]: Timeout detected for thread "MapBlockSendThread (Zenith)". ThreadState=Background, WaitSleepJoin. Last tick was 7578ms ago.

Now boot the region and it will crash and exit, and it cannot be booted.
Additional InformationError on fatal crash:

2019-05-21 20:55:20,667 ERROR [STARTUP]: Registration of region with grid failed, aborting startup due to Index was outside the bounds of the array. at OpenSim.Region.CoreModules.World.Warp3DMap.TerrainSplat.Splat(ITerrainChannel terrain, UUID[] textureIDs, Single[] startHeights, Single[] heightRanges, UInt32 regionPositionX, UInt32 regionPositionY, IAssetService assetService, IJ2KDecoder decoder, Boolean textureTerrain, Boolean averagetextureTerrain, Int32 twidth, Int32 theight) in O:\Opensim\Opensim Git Source\opensim\OpenSim\Region\CoreModules\World\Warp3DMap\TerrainSplat.cs:line 397
   at OpenSim.Region.CoreModules.World.Warp3DMap.Warp3DImageModule.CreateTerrain(Warp3D renderer) in O:\Opensim\Opensim Git Source\opensim\OpenSim\Region\CoreModules\World\Warp3DMap\Warp3DImageModule.cs:line 434
   at OpenSim.Region.CoreModules.World.Warp3DMap.Warp3DImageModule.GenImage() in O:\Opensim\Opensim Git Source\opensim\OpenSim\Region\CoreModules\World\Warp3DMap\Warp3DImageModule.cs:line 267
   at OpenSim.Region.CoreModules.World.Warp3DMap.Warp3DImageModule.CreateMapTile() in O:\Opensim\Opensim Git Source\opensim\OpenSim\Region\CoreModules\World\Warp3DMap\Warp3DImageModule.cs:line 211
   at OpenSim.Region.CoreModules.World.WorldMap.WorldMapModule.GenerateMaptile() in O:\Opensim\Opensim Git Source\opensim\OpenSim\Region\CoreModules\World\WorldMap\WorldMapModule.cs:line 1671
   at OpenSim.Region.Framework.Scenes.Scene.RegenerateMaptile() in O:\Opensim\Opensim Git Source\opensim\OpenSim\Region\Framework\Scenes\Scene.cs:line 5947
   at OpenSim.Region.Framework.Scenes.Scene.RegisterRegionWithGrid() in O:\Opensim\Opensim Git Source\opensim\OpenSim\Region\Framework\Scenes\Scene.cs:line 2209
   at OpenSim.OpenSimBase.CreateRegion(RegionInfo regionInfo, Boolean portadd_flag, Boolean do_post_init, IScene& mscene) in O:\Opensim\Opensim Git Source\opensim\OpenSim\Region\Application\OpenSimBase.cs:line 501O
TagsNo tags attached.
Git Revision or version numberOpensim Dev Master 4/24/2019 #11cad57c9cac5
Run Mode Grid (1 Region per Sim) , Grid (Multiple Regions per Sim)
Physics EngineBulletSim, ubODE
EnvironmentUnknown, .NET / Windows64
Mono VersionNone
Viewerany
Attached Filesjpg file icon 6728d049-c4af-45cc-86e8-de4f9f9d9129_texture.jpg [^] (7,637 bytes) 2019-05-22 10:25


png file icon 718189251411e9d6f2d2d32248981d37.png [^] (190,236 bytes) 2019-05-22 10:39

- Relationships

-  Notes
(0035232)
Ferd Frederix (reporter)
2019-05-22 08:40

On a system with about 100 regions, with maps set to the bare minimum without Warp3d, we get a continual stream of these. After regions all start, they stop.

10:33:25 - [WATCHDOG]: Timeout detected for thread "MapItemRequestThread (Edgewood)". ThreadState=Background, WaitSleepJoin. Last tick was 7094ms ago.
10:33:25 - [WATCHDOG]: Timeout detected for thread "MapBlockSendThread (Edgewood)". ThreadState=Background, WaitSleepJoin. Last tick was 5875ms ago.
10:33:38 - [WATCHDOG]: Timeout detected for thread "MapBlockSendThrea
(0035233)
BillBlight (developer)
2019-05-22 10:23

Did some digging, your terrain texture 2 is only 256x256, it should be 512x512 or 1024x1024.

Loaded the oar, got the same error as you.

Replaced terrain texture 2 with a proper size texture, map generates fine.


Ubit has been cleaning up the terrain code a bit and I'm sure added constraints for proper size textures that were not there before ..

Even the terrain window in the viewer says that they should be 512x512/1024x1024.
(0035234)
BillBlight (developer)
2019-05-22 10:26
edited on: 2019-05-22 10:40

I have attached terrain texture 2 as it is, inside the oar, converted to .jpg from .jp2.

And an attached image of the warp3d generated map

(0035235)
BillBlight (developer)
2019-05-22 10:29

And yes I know some of the built in textures are 256x256 or smaller, not sure why they work, could be bit depth as well ..
(0035236)
Ferd Frederix (reporter)
2019-05-22 11:05

Thanks for the research. How you figured that out is beyond me.

It appears to me there is no constraint on the texture size in Opensim. I know that texture on land often does not load on old OARS, possibly because of similar issues.

Now something has changed to break it when a 256X256 is loaded.
(0035237)
tampa (reporter)
2019-05-22 12:42

If my memory is not failing me this change was older as I remember having issues with another oar by the same creator. The fix there was simply deleting the texture and that was that. Reading through the code, it should work especially with 256 given that is the only size splat ever creates regardless of true region size. Perhaps the recent change has adjusted this, but requiring larger textures seems to be the exact opposite of what should make it work.
(0035238)
UbitUmarov (administrator)
2019-05-22 14:03

just tested with the 256x256 texture above and worked fine
well ugly terrain, but worked
will try the oar, asap
(0035239)
BillBlight (developer)
2019-05-22 14:24

Yeah it works with the converted one after I converted it from jp2 to jpg, and you can then use it, so it may be bit depth or just a corrupt texture ..
(0035240)
UbitUmarov (administrator)
2019-05-22 14:26

Ok the problem is not the texture size, but the terrain heights/elevation on the oar:
reading the oar on ...settings\Outworldz.xml :


  <GroundTextures>
    <Texture1>3b7a0bc6-2c77-402e-ad33-743ff8ccac7b</Texture1>
    <Texture2>6728d049-c4af-45cc-86e8-de4f9f9d9129</Texture2>
    <Texture3>179cdabd-398a-9b6b-1391-4dc333ba321f</Texture3>
    <Texture4>beb169c7-11ea-fff2-efe5-0f24dc881df2</Texture4>
    <ElevationLowSW>9.99999956202353E+38</ElevationLowSW>
    <ElevationLowNW>9.99999998050645E+32</ElevationLowNW>
    <ElevationLowSE>9.99999998050645E+32</ElevationLowSE>
    <ElevationLowNE>9.99999998050645E+32</ElevationLowNE>
    <ElevationHighSW>6.00000042896702E+39</ElevationHighSW>
    <ElevationHighNW>6.00000020820619E+33</ElevationHighNW>
    <ElevationHighSE>6.00000020820619E+33</ElevationHighSE>
    <ElevationHighNE>6.00000020820619E+33</ElevationHighNE>

values xxE+30.. are a bit too large ;)

no idea how you got that.
(0035241)
BillBlight (developer)
2019-05-22 14:28
edited on: 2019-05-22 14:42

ahhh HA, well so I was totally off base, that second texture just looked messed up when I loaded the oar so I changed it , and then it worked fine, but also when I changed it on that menu it reset the elevations , which are on the same page ..


Right place, wrong reason ..


(curious how numbers, with that many places, ever got entered in the first place, those are some crazy numbers.)

(0035242)
tampa (reporter)
2019-05-22 15:54

Seems like a rounding error, perhaps lib differences. Easy to fix setting max size, as redundant as that is. Is the original creator still around to perhaps provide some info on how/where those oars were made?
(0035243)
Ferd Frederix (reporter)
2019-05-22 21:20

Wonder if its 6.00000042896702E+39 or 6.00000020820619E+33 doing it?

</kidding>
(0035244)
Ferd Frederix (reporter)
2019-05-22 21:58

Marking as resolved - there was a 999999999999 set of digits in the Terrain Height which was easily fixed once located.

- Issue History
Date Modified Username Field Change
2019-05-21 19:44 Ferd Frederix New Issue
2019-05-22 08:40 Ferd Frederix Note Added: 0035232
2019-05-22 10:23 BillBlight Note Added: 0035233
2019-05-22 10:25 BillBlight File Added: 6728d049-c4af-45cc-86e8-de4f9f9d9129_texture.jpg
2019-05-22 10:26 BillBlight Note Added: 0035234
2019-05-22 10:29 BillBlight Note Added: 0035235
2019-05-22 10:39 BillBlight File Added: 718189251411e9d6f2d2d32248981d37.png
2019-05-22 10:40 BillBlight Note Edited: 0035234 View Revisions
2019-05-22 11:05 Ferd Frederix Note Added: 0035236
2019-05-22 12:42 tampa Note Added: 0035237
2019-05-22 14:03 UbitUmarov Note Added: 0035238
2019-05-22 14:24 BillBlight Note Added: 0035239
2019-05-22 14:26 UbitUmarov Note Added: 0035240
2019-05-22 14:28 BillBlight Note Added: 0035241
2019-05-22 14:28 BillBlight Note Edited: 0035241 View Revisions
2019-05-22 14:42 BillBlight Note Edited: 0035241 View Revisions
2019-05-22 15:54 tampa Note Added: 0035242
2019-05-22 21:20 Ferd Frederix Note Added: 0035243
2019-05-22 21:58 Ferd Frederix Git Revision or version number pensim Dev Master 4/24/2019 #11cad57c9cac5 => Opensim Dev Master 4/24/2019 #11cad57c9cac5
2019-05-22 21:58 Ferd Frederix Note Added: 0035244
2019-05-22 21:58 Ferd Frederix Status new => resolved


Copyright © 2000 - 2012 MantisBT Group
Powered by Mantis Bugtracker